package sb::Plugin::RealTimeHolidayCalendar;

use sb::Plugin ();

sb::Plugin->register_plugin(
    'lang' => {
        'ja' => 'euc',
        'en' => 'ascii',
    },
    'text' => {
        'type'    => 'cms',
        'name'    => 'RealTimeHolidayCalendar',
        'text'    => 'script for RealTime Holiday Calendar',
        'author'  => 'yujiro',
        'detail'  => 'http://www.koikikukan.com/',
        'version' => '1.00',
    },
    'data' => 0,
    'file' => 'realtime_holidaycalendar.txt',
);

sb::Plugin->register_content_module(
    'type'     => 'main',
    'callback' => \&sb::Content::RealTimeHolidayCalendar::_real_time_holiday_calendar,
    'field'    => 'rt_holiday_calendar',
);

package sb::Content::RealTimeHolidayCalendar;

sub _real_time_holiday_calendar {
    my $cms = shift;
    my %var = @_;
    my $data = <<EOF;

<script type="text/javascript">
<!--
function setWeekendAndHoliday() {
    var element = document.getElementById("rt_holiday_calendar");
    var link;
    if(element.getElementsByTagName('br').length != 0){
        var elements = element.getElementsByTagName('a');
        for (i=0; i < elements.length; i++) {
            if(elements[i].innerHTML == '&lt;&lt;'){
                link = element.getElementsByTagName('a')[i].getAttribute('href');
                break;
            }
        }
    } else {
        // for calendar2
        if(element.innerHTML.indexOf('&lt;&lt;') != -1){
            elements = element.getElementsByTagName('a');
            for (i=0; i < elements.length; i++) {
                if(elements[i].innerHTML == '&lt;&lt;'){
                    link = element.getElementsByTagName('a')[i].getAttribute('href');
                    break;
                }
            }
        } else {
            link = element.getElementsByTagName('a')[0].getAttribute('href');
        }
    }
    var ym = link.split("=")[1];
    var year = ym.substring(0, 4);
    var month = ym.substring(4);
    month++;
    if(month == 13){
        month = 1;
        year++;
    }

    var elements = element.getElementsByTagName("table");
    var spans = elements[0].getElementsByTagName("td");
    var day;

    for (i = 0; i < spans.length; i++) {
        if (spans[i].getAttribute("class") == "cell" ||
             spans[i].getAttribute("className") == "cell") {
            if(spans[i].innerHTML.indexOf("href") != -1){
                day = spans[i].getElementsByTagName("a")[0].innerHTML;
                day = day.replace(/<span class="today">(\\d+)<\\/span>/gi,"\$1");
                day = day.replace(/<span class=today>(\\d+)<\\/span>/gi,"\$1"); // for IE
                spans[i].getElementsByTagName("a")[0].innerHTML = day
            } else {
                day = spans[i].innerHTML;
                day = day.replace(/<span class="today">(\\d+)<\\/span>/gi,"\$1");
                day = day.replace(/<span class=today>(\\d+)<\\/span>/gi,"\$1"); // for IE
                spans[i].innerHTML = day;
            }

            if (isHoliday(year, month, day)) {
                if (isToday(year, month, day)) {
                    spans[i].setAttribute('class', 'tholiday');
                    spans[i].setAttribute('className', 'tholiday');
                } else {
                    spans[i].setAttribute('class', 'holiday');
                    spans[i].setAttribute('className', 'holiday');
                }
            } else if(isSaturday(year, month, day)) {
                if (isToday(year, month, day)) {
                    spans[i].setAttribute('class', 'tsaturday');
                    spans[i].setAttribute('className', 'tsaturday');
                } else {
                    spans[i].setAttribute('class', 'saturday');
                    spans[i].setAttribute('className', 'saturday');
                }
            } else if (isToday(year, month, day)) {
                spans[i].setAttribute('class', 'today');
                spans[i].setAttribute('className', 'today');
            }
        }
    }
}
setCurrentDate();
setWeekendAndHoliday();
//-->
</script>
EOF
    $cms->tag('rt_holiday_script' => $data);
    $cms->tag('rt_holiday_calendar_script' => '<script type="text/javascript" src="'.$var{'conf'}->value('conf_srv_base').'dayChecker.js" charset="utf-8"></script>');
    return 1;
}

1;
__END__
